"""This file contains the settings related to hardware configuration
and the fixed layout of the object dictionary."""

# LEDs
LED_RED = 1
LED_GREEN = 2
LED_YELLOW = 3
LED_BLUE = 4

# hardware dependent configuration
TIMER_SYNC = 1  # Timer 1
TIMER_HEARTBEAT_PRODUCER = 2  # Timer 2
TIMER_HEARTBEAT_CONSUMER = 3  # Timer 3
LED_SYNC = LED_BLUE  # set to None to disable
LED_HEARTBEAT_PRODUCER = LED_RED  # set to None to disable
LED_HEARTBEAT_CONSUMER = LED_YELLOW  # set to None to disable

# Node ID of master is fixed
MASTER_NODE_ID = 1

# pre-defined connection set configuration
# PDO1
TPDO_LOCAL_SCET_GET = 1
TPDO_SPACECRAFT_SCET_GET = 1
RPDO_LOCAL_SCET_GET = 1
# PDO2
TPDO_SEND_TC = 2
RPDO_RECEIVE_TC = 2
# PDO3
TPDO_SEND_TM = 3
TPDO_SEND_TM_REQ = 3
RPDO_RECEIVE_TM_REQ = 3
RPDO_RECEIVE_TM = 3

# COB-IDs of the pre-defined connection set
COB_ID_SYNC = 0x080
COB_ID_TPDO_1 = 0x180
COB_ID_RPDO_1 = 0x200
COB_ID_TPDO_2 = 0x280
COB_ID_RPDO_2 = 0x300
COB_ID_TPDO_3 = 0x380
COB_ID_RPDO_3 = 0x400
COB_ID_TPDO_4 = 0x480
COB_ID_RPDO_4 = 0x500
COB_ID_HEARTBEAT = 0x700

# operational states
STATE_CODE_INITIALIZING = 0x00
STATE_CODE_STOPPED = 0x04
STATE_CODE_OPERATIONAL = 0x05
STATE_CODE_PREOPERATIONAL = 0x7F

# object dictionary indeces
OD_INDEX_COMMUNICATION_CYCLE_PERIOD = 0x1006
OD_INDEX_CONSUMER_HEARTBEAT_TIME = 0x1016
OD_INDEX_PRODUCER_HEARTBEAT_TIME = 0x1017

OD_INDEX_TPDO1 = 0x1800
OD_INDEX_TPDO2 = 0x1801
OD_INDEX_TPDO3 = 0x1802
OD_INDEX_TPDO4 = 0x1803

OD_INDEX_TPDO1_MAPPING = 0x1A00
OD_INDEX_TPDO2_MAPPING = 0x1A01
OD_INDEX_TPDO3_MAPPING = 0x1A02
OD_INDEX_TPDO4_MAPPING = 0x1A03

OD_INDEX_REDUNDANCY_MANAGEMENT = 0x2000
OD_SUBINDEX_B_DEFAULT = 1
OD_SUBINDEX_T_TOGGLE = 2
OD_SUBINDEX_N_TOGGLE = 3
OD_SUBINDEX_C_TOGGLE = 4

OD_INDEX_SCET = 0x2001

# allows for 256 (=0x100, index) * 256 (subindex) * 8 bytes commands
OD_INDEX_TC = 0x6000
OD_INDEX_TM_REQ_CODE = 0x6100
# allows for 256 (=0x100, index) * 256 (subindex) * 8 bytes tm entries
OD_INDEX_TM = 0x6200
